package com.ibm.xtools.transform.samples.modeltotext.jet;

import java.util.Map;
import java.util.Iterator;
import com.ibm.xtools.transform.samples.modeltotext.JavaNameTool;
import org.eclipse.uml2.*;

public class DisplayTemplate
{
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = "<%@ page language=\"java\" %><%";
  protected final String TEXT_2 = NL;
  protected final String TEXT_3 = " ";
  protected final String TEXT_4 = " = ";
  protected final String TEXT_5 = "Factory.getService();";
  protected final String TEXT_6 = NL;
  protected final String TEXT_7 = " input = (";
  protected final String TEXT_8 = ")session.getAttribute(\"input\");" + NL + "// TODO set ";
  protected final String TEXT_9 = " appropriately";
  protected final String TEXT_10 = NL;
  protected final String TEXT_11 = " ";
  protected final String TEXT_12 = " = null;" + NL + "%><!DOCTYPE HTML PUBLIC \"-//W3C/DTD HTML 4.01 Transitional//EN\">" + NL + "<html>" + NL + "<head>" + NL + "<title>";
  protected final String TEXT_13 = "</title>" + NL + "</head>" + NL + "<body>" + NL + "<h1>";
  protected final String TEXT_14 = "</h1>" + NL + "<FORM method=\"post\" action=\"/";
  protected final String TEXT_15 = "/";
  protected final String TEXT_16 = "\">" + NL + "\t<TABLE border=\"0\">" + NL + "\t\t<TBODY>";
  protected final String TEXT_17 = NL + "\t\t\t<TR>" + NL + "\t\t\t\t<TD>";
  protected final String TEXT_18 = ":</TD>" + NL + "\t\t\t\t<TD><%= ";
  protected final String TEXT_19 = ".get";
  protected final String TEXT_20 = "() %></TD>" + NL + "\t\t\t</TR>";
  protected final String TEXT_21 = NL + "\t\t</TBODY>" + NL + "\t</TABLE>";
  protected final String TEXT_22 = NL + "    <input type=\"submit\" value=\"";
  protected final String TEXT_23 = "\" name=\"";
  protected final String TEXT_24 = "\">";
  protected final String TEXT_25 = NL + "\t<INPUT type=\"hidden\" name=\"userName\" value=\"<%= input.getUserName() %>\">" + NL + "</form>" + NL + "</body>" + NL + "</html>" + NL + "\t\t\t";

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    
// retrieve the context
Map context = (Map)argument;

// these should be in the context, but are not...
String webapp = "simplerolodex";
String uiserviceClass = "RolodexService";

// extract things from the context
State state = (State)context.get("state");

// *** Extract the applied stereotype, and get its values ***
Stereotype st = state.getAppliedStereotype("ScreenFlow::display");
String entity = (String)state.getValue(st, "entity");

// *** split the fields string into an array ***

String fieldsRaw = (String)state.getValue(st,"fields");
String fields[] = JavaNameTool.split(fieldsRaw,",");

// *** Build some variable names ***
String entityClass = entity;
String entityInstance = JavaNameTool.asAttribute(entityClass);
String screenInputClass = JavaNameTool.asClass(state.getName()) + "Input";
String uiserviceInstance = JavaNameTool.asAttribute(uiserviceClass);
String servletClass = JavaNameTool.asClass(state.getName() + "Handler");

    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append( uiserviceClass );
    stringBuffer.append(TEXT_3);
    stringBuffer.append( uiserviceInstance );
    stringBuffer.append(TEXT_4);
    stringBuffer.append( uiserviceClass);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(TEXT_6);
    stringBuffer.append( screenInputClass );
    stringBuffer.append(TEXT_7);
    stringBuffer.append( screenInputClass );
    stringBuffer.append(TEXT_8);
    stringBuffer.append( entityInstance );
    stringBuffer.append(TEXT_9);
    stringBuffer.append(TEXT_10);
    stringBuffer.append( entityClass );
    stringBuffer.append(TEXT_11);
    stringBuffer.append( entityInstance );
    stringBuffer.append(TEXT_12);
    stringBuffer.append( state.getName() );
    stringBuffer.append(TEXT_13);
    stringBuffer.append( state.getName() );
    stringBuffer.append(TEXT_14);
    stringBuffer.append( webapp );
    stringBuffer.append(TEXT_15);
    stringBuffer.append( servletClass );
    stringBuffer.append(TEXT_16);
    
for(int i = 0; i < fields.length; i++ ) {
    String field = fields[i];

    stringBuffer.append(TEXT_17);
    stringBuffer.append( field );
    stringBuffer.append(TEXT_18);
    stringBuffer.append( entityInstance );
    stringBuffer.append(TEXT_19);
    stringBuffer.append( JavaNameTool.asClass(field) );
    stringBuffer.append(TEXT_20);
    
}

    stringBuffer.append(TEXT_21);
    
for(Iterator i=state.getOutgoings().iterator(); i.hasNext(); ) {
	Transition transition = (Transition)i.next();

    stringBuffer.append(TEXT_22);
    stringBuffer.append( transition.getName() );
    stringBuffer.append(TEXT_23);
    stringBuffer.append( JavaNameTool.asAttribute(transition.getName()) );
    stringBuffer.append(TEXT_24);
    
}

    stringBuffer.append(TEXT_25);
    return stringBuffer.toString();
  }
}
