/*
 * Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms
 * and conditions in the IBM International Program License Agreement.
 *
 * (C) Copyright IBM Corporation 2003, 2004. All Rights Reserved. 
 */

package com.ibm.xtools.pluglets.ui.samples.workbench;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.ISelectionService;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;

import com.ibm.xtools.pluglets.Pluglet;

/**
 * Show current workbench selection.
 */
public class ShowSelection extends Pluglet {

	public void plugletmain(String[] args) {
		IWorkbench wb = PlatformUI.getWorkbench();
		IWorkbenchWindow wbw = wb.getActiveWorkbenchWindow();
		ISelectionService ss = wbw.getSelectionService();
		ISelection s = ss.getSelection();
		out.println("class: " + s.getClass().getName()); //$NON-NLS-1$
		out.println("toString(): " + s.toString()); //$NON-NLS-1$
	}

}